L.Control.ViewCenter = L.Control.extend({

	includes: L.Mixin.Events,

	options: {
		position: 'bottomright',
		title: 'Show items thumbnails'
	},

	onAdd: function (map) {
        // Find content container
        var content = this._contentContainer = L.DomUtil.get('scrollbar1');
	
        // Remove the content container from its original parent
        content.parentNode.removeChild(content);

		//  Create the buttom
		var container = this._container = L.DomUtil.create('div', 'leaflet-bar');
		L.DomUtil.addClass(container, "leaflet-container leaflet-control");

		/* Create Attibution div 
		this._attriblink = this._createButtonAttrib("Display map credits", "osm-info-circled leaflet-toggle");
		this._attrib = L.DomUtil.create('div', 'leaflet-control-attribution');
		this._attrib.innerHTML = "My attribution";
		this._attrib.style.display = 'block';
		this._attriblink.style.position = 'absolute';
		container.appendChild( this._attrib );
		L.DomUtil.addClass(this._attrib, 'leaflet-control ');
		*/
		
		// Create sidebar container
		this._sidebar = L.DomUtil.create('div', 'leaflet-viewbar');
		var nbshowall = L.DomUtil.create('b', 'nb_showall');
        var wrapper = L.DomUtil.create('div', 'jcarousel-wrapper');
		var jcarousel = L.DomUtil.create('div', 'jcarousel');
		var thumb = L.DomUtil.create('ul', 'jcarousel-thumb');
		//var thumbprev = L.DomUtil.create('a', 'jcarousel-control-prev');
		//var thumbnext = L.DomUtil.create('a', 'jcarousel-control-next');

		this._sidebar.setAttribute("id","sidebar-up");
		//this._sidebar.setAttribute('style','visibility:hidden;');
		L.DomUtil.addClass(this._sidebar, "bottom left");
		nbshowall.setAttribute("id","nb_showall");
		wrapper.setAttribute("id","jcarousel-wrapper");
		L.DomUtil.addClass(wrapper,"leaflet-control");
		jcarousel.setAttribute("id","jcarousel");
		thumb.setAttribute("id","jcarousel-thumb");
		//thumbprev.setAttribute("data-jcarouselcontrol", "true");
		//thumbprev.setAttribute("href", "#");
		//thumbnext.setAttribute("data-jcarouselcontrol", "true");
		//thumbnext.setAttribute("href", "#");

		jcarousel.appendChild( thumb );
		wrapper.appendChild( jcarousel );
		//wrapper.appendChild( thumbprev );
		//wrapper.appendChild( thumbnext );
		this._sidebar.appendChild( nbshowall );
		//this._sidebar.appendChild( wrapper );
		this._sidebar.appendChild( content );
		//container.appendChild( this._sidebar );
		map._controlContainer.insertBefore(this._sidebar, map._controlContainer.firstChild);
		//map._controlContainer.insertBefore(content, map._controlContainer.firstChild);

		this._button = this._createButton(this.options, "osm-angle-double-up leaflet-toggle", this._container, this._sidebar, map);
		container.setAttribute("id","leaflet-bar-up");

		return container;
	},
	
	_createButton: function (opts, className, container, fn, context) {
		var link = L.DomUtil.create('a', className, container);
		link.href = 'javascript:ShowThumbs();';
		link.title = opts.title;

        L.DomEvent
            .on(container, 'transitionend',
                this._handleTransitionEvent, this)
            .on(container, 'webkitTransitionEnd',
                this._handleTransitionEvent, this);

        // Make sure we don't drag the map when we interact with the content
        var stop = L.DomEvent.stopPropagation;
        L.DomEvent
            .on(this._sidebar, 'click', stop)
            .on(this._sidebar, 'mousedown', stop)
            .on(this._sidebar, 'touchstart', stop)
            .on(this._sidebar, 'dblclick', stop)
            .on(this._sidebar, 'mousewheel', stop)
            .on(this._sidebar, 'MozMousePixelScroll', stop);
			
		return link;
	},

	_createButtonAttrib: function (title, className) {
		var button = L.DomUtil.create('a', className, this._container);
		button.href = '#';
		button.title = title;

		//L.DomEvent
			//.on(button, 'click', L.DomEvent.stop, this)
			//.on(button, 'click', this._handleSubmit, this)			
			//.on(button, 'focus', this.collapseDelayedStop, this)
			//.on(button, 'blur', this.collapseDelayed, this);

		return button;
	},

    isVisible: function () {
        return L.DomUtil.hasClass(this._sidebar, 'visible');
    },

    show: function () {
		console.log(this.isVisible());
		//this._sidebar.removeAttribute('style');
		L.DomUtil.removeClass(this._button, 'osm-angle-double-up');
		L.DomUtil.addClass(this._button, 'osm-angle-double-down');
		L.DomUtil.addClass(this._sidebar, 'visible');
		this.fire('show');
    },

    hide: function (e) {
		console.log(this.isVisible());
		L.DomUtil.removeClass(this._sidebar, 'visible');
		L.DomUtil.removeClass(this._button, 'osm-angle-double-down');
		L.DomUtil.addClass(this._button, 'osm-angle-double-up');
		//this._sidebar.setAttribute('style','visibility:hidden;');
		this.fire('hide');
        if(e) {
            L.DomEvent.stopPropagation(e);
        }
    },

    toggle: function () {
        if (this.isVisible()) {
            this.hide();
        } else {
            this.show();
        }
    },
	
    _handleTransitionEvent: function (e) {
        this.fire(this.isVisible() ? 'shown' : 'hidden');
    }

});

L.control.viewcenter = function (options) {
	return new L.Control.ViewCenter(options);
};

